package oko.tm.oko_s2;



import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;

import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.support.v4.content.LocalBroadcastManager;
import android.util.Log;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.InterruptedIOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;
import java.net.SocketException;
import java.net.UnknownHostException;

import static android.support.v4.app.ActivityCompat.startActivity;

/**
 * Created by Boby on 24.04.2016.
 */

public class ClientThread implements Runnable {

    public static final  String TCP_BROADCAST_ACTION = "oko.tm.oko_s2.servicebackbroadcast";
    public static final  String CLIENT_BROADCAST_RECIEVE_COMMAND = "oko.tm.oko_s2.clientreceivecommand";
    public static final  int PERIODIC_QUERY = 30; //second
    private static final int SERVERPORT = 31200;
    private static final String SERVER_IP = "ok.webhop.net";//"server.oko.tm"; "localhost" 78.27.132.52

    static final String LOG_TAG = "myLogs";


    public static final  String PARAM_TYPE = "type";
    public static final  String PARAM_DATA = "data";
    public static final  String STATUS_CONNECTION = "0"; //param_type
    public static final  String CONNECT_NO = "0"; //param_data
    public static final  String CONNECT_TO_SERVER = "1"; //param_data
    public static final  String CONNECT_TO_DEVISE = "2"; //param_data

    public  static final String DEVICE_DATA = "1"; //param_type

    public static volatile boolean MainActivity_Started=false;
    public static volatile boolean stopThread_client = false;
    public static volatile boolean stopThread_periodic = false;
    private boolean stopThread_client_done=false;
    private static Socket socket = new Socket();
    private volatile boolean socket_timeout=false;
    private static volatile boolean socket_opened=false;

    private int sever_reconnection_count=0;

    BufferedReader reader_socket=null;

    public static BroadcastReceiver br_client;

    @Override
    public void run() {
        String data;
        int socket_timeout_count=0;

        //boolean temp=false;
        try {
            Log.d(LOG_TAG, "Client thread start");

            // создаем BroadcastReceiver для приема данных с sms_receiver (вариант через broadcast)
            br_client = new BroadcastReceiver() {
                // действия при получении сообщений
                public void onReceive(Context context, Intent intent) {

                    //String message_text = intent.getStringExtra("message");
                    String command = intent.getStringExtra("command");
                    Log.d(LOG_TAG, "Client br_onReceive: command = " + command);
                    Send_To_Server(command);
                    //sms_anal(message_text, sender);
                }
            };
            // создаем фильтр для BroadcastReceiver
            IntentFilter intFilt_sms = new IntentFilter(CLIENT_BROADCAST_RECIEVE_COMMAND);
            // регистрируем (включаем) BroadcastReceiver
            //registerReceiver(br_sms, intFilt_sms);
        /*The LocalBroadcastManager class is a helper class to register local broadcast receivers as well
        as send broadcasts of Intents to them within our own app’s process rather than sending global broadcasts
        using sendBroadcast() as we saw before. It is more efficient as well as secured compared to global broadcasts
        through the system as the data won’t leave our app nor can we receive from other foreign apps.*/
            LocalBroadcastManager.getInstance(MyService.mContext).registerReceiver(br_client, intFilt_sms);



            periodic_query();
            //InetAddress serverAddr = InetAddress.getByName(SERVER_IP);
            //socket = new Socket(serverAddr, SERVERPORT);
            //----- set socket read timeout to 15 seconds -----
            //socket.setSoTimeout(15000);
            //if (socket !=null) Log.d(LOG_TAG, "Socket opened");

            //socket.connect(new InetSocketAddress(SERVER_IP,SERVERPORT),15000);

            Connect_to_server();


            while (!stopThread_client)
            {
                try {
                    data = readData();

                    if (data.length() > 0 && !stopThread_client && !socket_timeout) {

                        Log.d(LOG_TAG, "Socket received data: " + data);

                        try {
                            Intent intent1 = new Intent(TCP_BROADCAST_ACTION);
                            intent1.putExtra(PARAM_TYPE, STATUS_CONNECTION);
                            intent1.putExtra(PARAM_DATA, CONNECT_TO_SERVER);
                            //MyService.mContext.sendBroadcast(intent1);
                            LocalBroadcastManager.getInstance(MyService.mContext).sendBroadcast(intent1);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }

                        //alive message to supervisor
                        try {
                            Intent intent1 = new Intent(SupervisorService.SUPERVISOR_BROADCAST_RECIEVE_ALIVE);
                            intent1.putExtra("command","ok");
                            //intent1.putExtra(PARAM_DATA, CONNECT_NO);
                            //MyService.mContext.sendBroadcast(intent1);
                            LocalBroadcastManager.getInstance(MyService.mContext).sendBroadcast(intent1);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }

                        try {
                            if (data.startsWith("{")) {


                                /* OKO-S2
                                * {13227009840343,01,02,01F0,18,3.0.0,OKO-S2}
                                * {866104020810332,F9,0B,05C8,1F,3.0.3,OKO-S2}
                                * Termo&Humidity {866104020810332,F9,0B,05C8,1F,3.0.3,OKO-S2,12.4,56.8}
                                *
                                * {13227009840343,0036,0200,0F00,00B9,18,1918181819181818,CCF189FB000055FB18FA55FBA6FB000000000000000018EAEFABF1FB18EAF0BB,07690717000000000012001200120000,1.0.9,OKO-PRO}
                                *OKO-U2
                                *{863591021960863,00FF,0200,2F101000,0000,00,8080808080808080,0000000000000000000000000000000000000000000000000000000000000000,072D06E00000000000000FFB0FA40ABE0FFE0FFE0FFE0FFE0FFE0FFE0FFE0FFE,2.2.1_,OKO-U2,,}
                                * {863591021960863,00FF,0200,2F101000,0000,00,8080808080808080,0000000000000000000000000000000000000000000000000000000000000000,072D06E00000000000000FFB0FA40ABE0FFE0FFE0FFE0FFE0FFE0FFE0FFE0FFE,2.2.1_,OKO-PRO,,}
                                * */
                                String[] requestParts = data.split(","); //data packet

                                int num_fields = requestParts.length;

                                //***************************************************************************
                                //проверка протокола ТСР от прибора OKO-S2

                                if (num_fields>6) {


                                    if (requestParts[6].substring(0, 6).equals("OKO-S2")) {
                                        //event
                                        int event_code = 200;
                                        try {
                                            event_code = 300 + hex2decimal(requestParts[1]);
                                        } catch (Exception ex) {
                                        }

                                        if (event_code != 549 && event_code != 550 && event_code != 540)
                                        {

                                            if (!MainActivity_Started)
                                            {

                                                    /*
                                                    //перезапускаем приложение, если оно не запущено еще
                                                    Intent StartActivity = new Intent();
                                                    StartActivity.setAction(Intent.ACTION_MAIN);
                                                    StartActivity.addCategory(Intent.CATEGORY_LAUNCHER);
                                                    StartActivity.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_LAUNCHED_FROM_HISTORY);
                                                    ComponentName cn = new ComponentName(MyService.mContext, MainActivity.class);
                                                    StartActivity.setComponent(cn);
                                                    MyService.mContext.startActivity(StartActivity);
                                                    */


                                                new Thread(new Runnable() {
                                                    public void run() {
                                                        try {
                                                            //перезапускаем приложение, если оно не запущено еще
                                                            Intent StartActivity = new Intent();
                                                            StartActivity.setAction(Intent.ACTION_MAIN);
                                                            StartActivity.addCategory(Intent.CATEGORY_LAUNCHER);
                                                            StartActivity.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_LAUNCHED_FROM_HISTORY );
                                                            ComponentName cn = new ComponentName(MyService.mContext, MainActivity.class);
                                                            StartActivity.setComponent(cn);
                                                            MyService.mContext.startActivity(StartActivity);
                                                        } catch (Exception e) {
                                                            e.printStackTrace();
                                                        }

                                                    }
                                                }).start();


                                                int timeout = 100;
                                                while (!MainActivity_Started && timeout != 0) {
                                                    Thread.currentThread();
                                                    try {
                                                        Thread.sleep(100);
                                                    } catch (InterruptedException e) {
                                                        e.printStackTrace();
                                                    }
                                                    timeout--;
                                                }
                                                Log.d(LOG_TAG, "Startup: " + timeout);

                                                Thread.currentThread();
                                                try {
                                                    Thread.sleep(1000);
                                                } catch (InterruptedException e) {
                                                    e.printStackTrace();
                                                }
                                            }
                                        }

                                        //MainActivity.Parser.obtainMessage(1, 10, 20, data).sendToTarget();

                                        //передаем данные в приемник
                                        try {
                                            Intent intent2 = new Intent(TCP_BROADCAST_ACTION);
                                            intent2.putExtra(PARAM_TYPE, DEVICE_DATA);
                                            intent2.putExtra(PARAM_DATA, data);
                                            //MyService.mContext.sendBroadcast(intent2);
                                            LocalBroadcastManager.getInstance(MyService.mContext).sendBroadcast(intent2);
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }

                                    }
                                }
                            }
                        } catch (Exception ex) {
                            ex.printStackTrace();
                        }

                    }
                    else
                    {
                        Log.d(LOG_TAG, "Socket failure");
                        if (!stopThread_client && (socket_timeout || !(data.length() > 0))) {

                            try {
                                Intent intent1 = new Intent(TCP_BROADCAST_ACTION);
                                intent1.putExtra(PARAM_TYPE, STATUS_CONNECTION);
                                intent1.putExtra(PARAM_DATA, CONNECT_NO);
                                //MyService.mContext.sendBroadcast(intent1);
                                LocalBroadcastManager.getInstance(MyService.mContext).sendBroadcast(intent1);
                            } catch (Exception e) {
                                e.printStackTrace();
                            }


                            socket_timeout_count++;
                            Log.d(LOG_TAG, "Socket timeout event #" + socket_timeout_count);
                            Connect_to_server();

                        }
                    }


                } catch (Exception e) {
                    // TODO Auto-generated catch block
                    //Log.d(MainActivity.TAG, "Ошибка приема");
                    //e.printStackTrace();
                }
            }

            socket_opened=false;
            if (socket.isConnected()) {
                socket.close();
                Log.d(LOG_TAG, "Socket closed");
            }


        } catch (UnknownHostException e1) {
            e1.printStackTrace();
        } catch (IOException e1) {
            e1.printStackTrace();
        }

        //stopThread_client = false;

        MainActivity.Client_Thread_stop=true;
        stopThread_client_done=true;

        try {
            // дерегистрируем (выключаем) BroadcastReceiver
            //unregisterReceiver(br_tcp);
            LocalBroadcastManager.getInstance(MyService.mContext).unregisterReceiver(br_client);
            Log.d(LOG_TAG, "unregister Client_Receiver in Client thread");
        } catch (Exception e) {
            //e.printStackTrace();
        }
        Log.d(LOG_TAG, "Client thread closed");
    }

    //ESTABLISH CONNECTION TO SERVER
    private void Connect_to_server(){
        boolean Connected=false;
        socket_opened=false;
        InetAddress serverAddr = null;
        int temp=0;
        int try_num=0;
        sever_reconnection_count++;
        while (!Connected && !stopThread_client) {

            try {
                serverAddr = InetAddress.getByName(SERVER_IP);
            } catch (UnknownHostException e) {
                e.printStackTrace();
            }

            Connected=true;
            try {

                if (socket.isConnected()) {
                    socket.close(); //after socket closing we need new Socket() constructor !!!
                    //while (!socket.isClosed()) {}
                    Log.d(LOG_TAG, "Socket closed");
                }
                try_num++;
                Log.d(LOG_TAG, "Try open socket, #"+try_num);
                //socket = new Socket(serverAddr, SERVERPORT);
                //----- set socket read timeout to 10 seconds -----
                //socket.setSoTimeout(10000);

                SocketAddress sockaddr = new InetSocketAddress(serverAddr, SERVERPORT);
                // Create your socket
                socket = new Socket();
                // Connect with 15 s timeout
                socket.connect(sockaddr, 15000);
            }
            // Exception thrown when network timeout occurs
            catch (InterruptedIOException iioe)
            {
                Connected=false;
                System.err.println ("Remote host timed out during read operation: " +iioe);
                Log.d(LOG_TAG, "Error during connection to server: " +iioe);
            }
            catch (UnknownHostException e) {
                //e.printStackTrace();
                Connected=false;
                System.err.println("Error during connection to server: " + e);
            }
            // Exception thrown when general network I/O error occurs
            catch (IOException ioe)
            {
                Connected=false;
                System.err.println("Network I/O error - " + ioe);
                Log.d(LOG_TAG, "Error during connection to server: " + ioe);
            }

            temp++;
            if (!Connected && !stopThread_client) {
                //pause
                int second=0;
                Thread.currentThread();
                try {
                    while (second<2*PERIODIC_QUERY && !stopThread_client) {
                        Thread.sleep(1000);
                        second++;
                    }
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }

        if (!stopThread_client) {
            socket_opened = true;
            socket_timeout = false;

            try {
                socket.setSoTimeout(2 * PERIODIC_QUERY * 1000); //2*PERIODIC_QUERY * 1000
                reader_socket = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            } catch (SocketException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

            Send_To_Server(""); //пустой запрос на прибор

            // If socket constructor returned without error,
            // then connection finished

            if (socket.isConnected()) {
                Log.d(LOG_TAG, "Socket opened: " + sever_reconnection_count);

            }
        }
    }

    //read line from socket with timeout
    private String readData() throws IOException
    {
        String line="";

        //BufferedReader reader_socket = new BufferedReader( new InputStreamReader(socket.getInputStream()));

        try {
            socket.setSoTimeout(2*PERIODIC_QUERY * 1000);
            line = reader_socket.readLine();
        }
        // Exception thrown when network timeout occurs
        catch (InterruptedIOException iioe)
        {
            socket_timeout=true;
            System.err.println ("Remote host timed out during read operation");
        }
        // Exception thrown when general network I/O error occurs
        catch (IOException ioe)
        {
            socket_timeout=true;
            System.err.println ("Network I/O error - " + ioe);
        }
        //Log.d(MainActivity.TAG, "Получены данные");

        return line;
    }

    private int hex2decimal(String s) {
        String digits = "0123456789ABCDEF";
        s = s.toUpperCase();
        int val = 0;
        for (int i = 0; i < s.length(); i++) {
            char c = s.charAt(i);
            int d = digits.indexOf(c);
            val = 16*val + d;
        }
        return val;
    }

    //---try sends a message to TCP-server ---
    //public static synchronized void send_to_server(String command) {
    private void Send_To_Server(String command) {
        try {
            if (socket_opened) {
                Log.d(LOG_TAG, "Send command to Socket: " + command);

                String imei;
                imei = getIMEI(MyService.mContext);

                String password;
                password = getPassword(MyService.mContext);

                String str = "";
                if ("".equals(command)) {
                    str = "{" + imei + "/COMMAND:" + ";/OKO-S2}\r";
                } else {
                    str = "{" + imei + "/COMMAND:" + password + command + ";/OKO-S2}\r";
                }

                //Log.d(LOG_TAG, "Send command to Socket: " + str);
                PrintWriter out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())), true);
                out.println(str);
            }


        } catch (UnknownHostException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //для работы с файлом с настройками
    private static SharedPreferences getPrefs(Context context) {
        return context.getSharedPreferences("oko_s2_settings", Context.MODE_PRIVATE);
    }

    public static String getIMEI(Context context) {
        return getPrefs(context).getString("imei", "no_imei");
    }

    public static String getPassword(Context context) {
        return getPrefs(context).getString("password", "1234");
    }

    public static void setUsername(Context context, String input) {
        SharedPreferences.Editor editor = getPrefs(context).edit();
        editor.putString("username_key", input);
        editor.commit();
    }


    private void periodic_query(){
        new Thread(new Runnable() {
            public void run() {
                int second=0;
                try {
                    while (!stopThread_periodic) {
                        try {
                            Thread.currentThread();
                            Thread.sleep(1000);
                            second++;
                            if (second==PERIODIC_QUERY && !stopThread_periodic) {
                                second=0;
                                try {
                                    Intent intent1 = new Intent(TCP_BROADCAST_ACTION);
                                    intent1.putExtra(PARAM_TYPE, STATUS_CONNECTION);
                                    intent1.putExtra(PARAM_DATA, CONNECT_NO);
                                    //MyService.mContext.sendBroadcast(intent1);
                                    LocalBroadcastManager.getInstance(MyService.mContext).sendBroadcast(intent1);
                                } catch (Exception e) {
                                    e.printStackTrace();
                                }
                                Send_To_Server(""); //пустой запрос на прибор
                            }
                        } catch (Exception e) {
                            // TODO Auto-generated catch block
                            e.printStackTrace();
                        }
                    }
                    //stopThread_periodic = false;
                    MainActivity.Periodic_Thread_stop=true;
                    Log.d(LOG_TAG, "Periodic query thread closed");

                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }).start();
    }
}





