package oko.tm.oko_s2;

import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.IBinder;
import android.support.v4.content.LocalBroadcastManager;
import android.util.Log;

public class MyService extends Service {

    final String LOG_TAG = "myLogs";
    public static Context mContext;
    //private Thread thread_client;
    //private Thread thread_periodic;
    public void onCreate() {
        super.onCreate();
        mContext=this;
        Log.d(LOG_TAG, "Service onCreate");

        new Thread(new ClientThread()).start();

        //new Thread(new PeriodicQuery()).start();

        //thread_client=new Thread(new ClientThread());
        //thread_client.start(); //запуск нового потока для IP-клиента

        //thread_periodic=new Thread(new PeriodicQuery());
        //thread_periodic.start(); //запуск нового потока для периодического опроса IP-клиента


    }

    public int onStartCommand(Intent intent, int flags, int startId) {
        Log.d(LOG_TAG, "Service_onStartCommand");

        //MainTask();
        //return super.onStartCommand(intent, flags, startId);
        readFlags(flags);
        //MyRun mr = new MyRun(startId);
        //new Thread(mr).start();
        Log.d(LOG_TAG, "#" + startId + " create");
        return START_STICKY; // START_STICKY; //Это значит, что сервис будет восстановлен после убийства.
        /*Both codes are only relevant when the phone runs out of memory and kills the service before it finishes executing.
        START_STICKY tells the OS to recreate the service after it has enough memory and call onStartCommand()
        again with a null intent. START_NOT_STICKY tells the OS to not bother recreating the service again.
        There is also a third code START_REDELIVER_INTENT that tells the OS to recreate the service AND redelivery the same intent
        to onStartCommand().
         */
    }

    public void onDestroy() {
        super.onDestroy();
        try {
            // дерегистрируем (выключаем) BroadcastReceiver
            //unregisterReceiver(br_tcp);
            //LocalBroadcastManager.getInstance(mContext).unregisterReceiver(ClientThread.br_client);
            //Log.d(LOG_TAG, "unregister Client_Receiver in Service thread");
        } catch (Exception e) {
            //e.printStackTrace();
        }
        ClientThread.stopThread_client=true;
        ClientThread.stopThread_periodic=true;
        Log.d(LOG_TAG, "Service_onDestroy");

    }

    public IBinder onBind(Intent intent) {
        Log.d(LOG_TAG, "Service_onBind");
        return null;
    }

    void readFlags(int flags) {
        if ((flags&START_FLAG_REDELIVERY) == START_FLAG_REDELIVERY)
            Log.d(LOG_TAG, "START_FLAG_REDELIVERY");
        if ((flags&START_FLAG_RETRY) == START_FLAG_RETRY)
            Log.d(LOG_TAG, "START_FLAG_RETRY");
    }

    class MyRun implements Runnable {

        int startId;

        public MyRun(int startId) {
            this.startId = startId;
            Log.d(LOG_TAG, "MyRun#" + startId + " create");
        }

        public void run() {
            Log.d(LOG_TAG, "MyRun#" + startId + " start");
            try {
                //TimeUnit.SECONDS.sleep(15);
            } catch (Exception e) {
                //e.printStackTrace();
            }
            //stop();
        }

        void stop() {
            Log.d(LOG_TAG, "MyRun#" + startId + " end, stopSelfResult("
                    + startId + ") = " + stopSelfResult(startId));
        }
    }


}