package oko.tm.oko_s2;


import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v4.content.LocalBroadcastManager;
import android.telephony.SmsMessage;
import android.widget.Toast;




public class SmsReceiver extends BroadcastReceiver
{
    public final static String SMS_BROADCAST_ACTION = "oko.tm.oko_s2.smsreceiverbackbroadcast";
    // это будет именем файла настроек
    //public static final String APP_PREFERENCES = "oko_s2_settings";
    public static volatile boolean MainActivity_Started=false;

    //public static final String APP_PREFERENCES_PHONE = "phone";
    public String PHONE_NUMBER = "";
    public int PHONE_NUMBER_TAIL=9;
    Context mcontext;




    @Override
    public void onReceive(Context context, Intent intent)
    {
        mcontext=context;
        //----------- работа с файлом, содержащий настройки
        SharedPreferences mSettings = context.getSharedPreferences(MainActivity.APP_PREFERENCES,
                Context.MODE_PRIVATE);


        //------------ вычитываем телефонный номер GSM-розетки
        if(mSettings.contains(MainActivity.APP_PREFERENCES_PHONE)) {
            PHONE_NUMBER=mSettings.getString(MainActivity.APP_PREFERENCES_PHONE, "");
        }

        //---get the SMS message passed in---
        Bundle bundle = intent.getExtras();
        SmsMessage[] msgs = null;
        String str = "", message_from="", message_text="", phone1="", phone2="";
        if (bundle != null)
        {
            //---retrieve the SMS message received---
            Object[] pdus = (Object[]) bundle.get("pdus");
            msgs = new SmsMessage[pdus.length];
            for (int i=0; i<msgs.length; i++)
            {
                msgs[i] = SmsMessage.createFromPdu((byte[])pdus[i]);
                message_from += msgs[i].getOriginatingAddress();
                message_text += msgs[i].getMessageBody().toString();
                str += "Входящая SMS от " + msgs[i].getOriginatingAddress();
                str += " :\n";
                str += msgs[i].getMessageBody().toString();
                str += "\n";
            }

            phone1=PHONE_NUMBER;
            phone2=message_from;
            // ----- сравниеваем номер входной смс с номером прибора - сравниваем "хвост"
            if (PHONE_NUMBER.length()>PHONE_NUMBER_TAIL) {
                phone1=PHONE_NUMBER.substring(PHONE_NUMBER.length()-PHONE_NUMBER_TAIL).toString();

                if (message_from.length()>PHONE_NUMBER_TAIL)
                    phone2=message_from.substring(message_from.length()-PHONE_NUMBER_TAIL);
            }

            if (phone1.equals(phone2))
            {

                //---display the new SMS message---
                Toast.makeText(context, str, Toast.LENGTH_SHORT).show();

                /*
                //--- перезапускаем приложение
                Intent startActivity = new Intent();
                startActivity.setClass(context, MainActivity.class);
                startActivity.setAction(MainActivity.class.getName());
                startActivity.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TOP );
                startActivity.putExtra("message", message_text);
                startActivity.putExtra("sender", message_from);
                context.startActivity(startActivity);
                */


                if (!MainActivity_Started) {

                    //--- перезапускаем приложение
                    Intent startActivity = new Intent();
                    startActivity.setClass(context, MainActivity.class);
                    startActivity.setAction(MainActivity.class.getName());
                    startActivity.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TOP );
                    startActivity.putExtra("message", message_text);
                    startActivity.putExtra("sender", message_from);
                    context.startActivity(startActivity);

                    /*
                    new Thread(new Runnable() {
                        public void run() {
                        //перезапускаем приложение, если оно не запущено еще
                        Context context=mcontext;
                        Intent StartActivity = new Intent();
                        StartActivity.setAction(Intent.ACTION_MAIN);
                        StartActivity.addCategory(Intent.CATEGORY_LAUNCHER);
                        StartActivity.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_LAUNCHED_FROM_HISTORY);
                        ComponentName cn = new ComponentName(context, MainActivity.class);
                        StartActivity.setComponent(cn);
                        context.startActivity(StartActivity);
                        }
                    }).start();


                    //перезапускаем приложение, если оно не запущено еще
                    //Intent StartActivity = new Intent();
                    //StartActivity.setAction(Intent.ACTION_MAIN);
                    //StartActivity.addCategory(Intent.CATEGORY_LAUNCHER);
                    //StartActivity.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_LAUNCHED_FROM_HISTORY);
                    //ComponentName cn = new ComponentName(context, MainActivity.class);
                    //StartActivity.setComponent(cn);
                    //context.startActivity(StartActivity);


                    int timeout = 100;
                    while (!MainActivity_Started && timeout != 0) {
                        Thread.currentThread();
                        try {
                            Thread.sleep(100);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                        timeout--;
                    }

                    Thread.currentThread();
                    try {
                        Thread.sleep(3000);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    */
                }
                else {

                    //передаем данные в приемник
                    try {
                        Intent intent1 = new Intent(SMS_BROADCAST_ACTION);
                        intent1.putExtra("message", message_text);
                        intent1.putExtra("sender", message_from);
                        //context.sendBroadcast(intent1);
                        LocalBroadcastManager.getInstance(context).sendBroadcast(intent1);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }


            } else {



            }


        }
    }
}
