package oko.tm.oko_s2;

import android.app.ActivityManager;
import android.app.Service;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.IBinder;
import android.support.v4.content.LocalBroadcastManager;
import android.util.Log;

public class SupervisorService extends Service {

    final String LOG_TAG = "myLogs";
    public static Context mContext;
    private boolean stopThread_supervisor=false;
    int second=0;
    public static BroadcastReceiver br_supervisor;
    public static final  String SUPERVISOR_BROADCAST_RECIEVE_ALIVE = "oko.tm.oko_s2.supervisorreceivealive";

    public void onCreate() {
        super.onCreate();
        mContext=this;
        Log.d(LOG_TAG, "Supervisor Service onCreate");
        periodic_check();
    }

    public int onStartCommand(Intent intent, int flags, int startId) {
        Log.d(LOG_TAG, "Supervisor Service_onStartCommand");

        //MainTask();
        //return super.onStartCommand(intent, flags, startId);
        readFlags(flags);
        //MyRun mr = new MyRun(startId);
        //new Thread(mr).start();
        Log.d(LOG_TAG, "Supervisor #" + startId + " create");
        return START_STICKY; // START_STICKY; //Это значит, что сервис будет восстановлен после убийства.
        /*Both codes are only relevant when the phone runs out of memory and kills the service before it finishes executing.
        START_STICKY tells the OS to recreate the service after it has enough memory and call onStartCommand()
        again with a null intent. START_NOT_STICKY tells the OS to not bother recreating the service again.
        There is also a third code START_REDELIVER_INTENT that tells the OS to recreate the service AND redelivery the same intent
        to onStartCommand().
         */
    }

    public void onDestroy() {
        super.onDestroy();
        stopThread_supervisor=true;
        try {
            // дерегистрируем (выключаем) BroadcastReceiver
            //unregisterReceiver(br_tcp);
            LocalBroadcastManager.getInstance(mContext).unregisterReceiver(br_supervisor);
            Log.d(LOG_TAG, "unregister Supervisor_Receiver in Service supervisor");
        } catch (Exception e) {
            //e.printStackTrace();
        }
        Log.d(LOG_TAG, "Supervisor Service_onDestroy");

    }

    public IBinder onBind(Intent intent) {
        Log.d(LOG_TAG, "Supervisor Service_onBind");
        return null;
    }

    void readFlags(int flags) {
        if ((flags&START_FLAG_REDELIVERY) == START_FLAG_REDELIVERY)
            Log.d(LOG_TAG, "START_FLAG_REDELIVERY");
        if ((flags&START_FLAG_RETRY) == START_FLAG_RETRY)
            Log.d(LOG_TAG, "START_FLAG_RETRY");
    }

    class MyRun implements Runnable {

        int startId;

        public MyRun(int startId) {
            this.startId = startId;
            Log.d(LOG_TAG, "Supervisor  MyRun#" + startId + " create");
        }

        public void run() {
            Log.d(LOG_TAG, "Supervisor  MyRun#" + startId + " start");
            try {
                //TimeUnit.SECONDS.sleep(15);
            } catch (Exception e) {
                //e.printStackTrace();
            }
            //stop();
        }

        void stop() {
            Log.d(LOG_TAG, "Supervisor  MyRun#" + startId + " end, stopSelfResult("
                    + startId + ") = " + stopSelfResult(startId));
        }
    }

    private void periodic_check(){
        new Thread(new Runnable() {
            public void run() {
                try {

                    // создаем BroadcastReceiver для приема данных с sms_receiver (вариант через broadcast)
                    br_supervisor = new BroadcastReceiver() {
                        // действия при получении сообщений
                        public void onReceive(Context context, Intent intent) {

                            //String message_text = intent.getStringExtra("message");
                            String command = intent.getStringExtra("alive");
                            Log.d(LOG_TAG, "Supervisor br_onReceive alive ");
                            second=0;
                        }
                    };
                    // создаем фильтр для BroadcastReceiver
                    IntentFilter intFilt_sms = new IntentFilter(SUPERVISOR_BROADCAST_RECIEVE_ALIVE);
                    // регистрируем (включаем) BroadcastReceiver
                    //registerReceiver(br_sms, intFilt_sms);
                    /*The LocalBroadcastManager class is a helper class to register local broadcast receivers as well
                    as send broadcasts of Intents to them within our own app’s process rather than sending global broadcasts
                    using sendBroadcast() as we saw before. It is more efficient as well as secured compared to global broadcasts
                    through the system as the data won’t leave our app nor can we receive from other foreign apps.*/
                    LocalBroadcastManager.getInstance(mContext).registerReceiver(br_supervisor, intFilt_sms);



                    while (!stopThread_supervisor) {
                        try {
                            Thread.currentThread();
                            Thread.sleep(1000);
                            second++;
                            if (second>(3*ClientThread.PERIODIC_QUERY)&& !stopThread_supervisor) {
                                second=0;
                                Reset_Connection();
                            }
                        } catch (Exception e) {
                            // TODO Auto-generated catch block
                            e.printStackTrace();
                        }
                    }
                    // дерегистрируем (выключаем) BroadcastReceiver
                    //unregisterReceiver(br_tcp);
                    LocalBroadcastManager.getInstance(mContext).unregisterReceiver(br_supervisor);
                    Log.d(LOG_TAG, "unregister Supervisor_Receiver in periodic supervisor thread");

                    Log.d(LOG_TAG, "Periodic supervisor thread closed");

                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }).start();
    }

    private void Reset_Connection(){
        MainActivity.Service_Restart=true;
        //btn_restart_connection.setEnabled(false);
        try{
            //Command=Form_T(txtCommand.getText().toString());
            //SharedPreferences.Editor editor = mSettings.edit();
            if ( isMyServiceRunning(oko.tm.oko_s2.MyService.class)) {
                //STOP SERVICE
                MainActivity.Client_Thread_stop = false;
                MainActivity.Periodic_Thread_stop = false;
                stopService(new Intent(mContext, MyService.class));
                //try_send_to_server("");
                int timeout = 2*ClientThread.PERIODIC_QUERY;
                while (timeout != 0 && !(MainActivity.Client_Thread_stop && MainActivity.Periodic_Thread_stop)) {
                    Thread.currentThread();
                    try {
                        Thread.sleep(1000); //1 second
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    timeout--;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        //START SERVICE TCP-SOCKET COMMUNICATION
        try {
            ClientThread.stopThread_periodic=false;
            ClientThread.stopThread_client=false;
        } catch (Exception e) {
            e.printStackTrace();
        }
        new Thread(new Runnable() {
            public void run() {
                try {
                    startService(new Intent(mContext, MyService.class)); //запускаем сервис для работы через IP в отдельном потоке
                } catch (Exception e) {
                    e.printStackTrace();
                }

            }
        }).start();



        //startService(new Intent(mContext, MyService.class));

        //editor.putString(APP_PREFERENCES_SERVICE, "1");
        //btn_restart_connection.setEnabled(true);
        MainActivity.Service_Restart=false;
    }

    //проверка запущен или нет сервис  - для проверки isMyServiceRunning(MyService.class)
    private boolean isMyServiceRunning(Class<?> serviceClass) {
        ActivityManager manager = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
        for (ActivityManager.RunningServiceInfo service : manager.getRunningServices(Integer.MAX_VALUE)) {
            if (serviceClass.getName().equals(service.service.getClassName())) {
                return true;
            }
        }
        return false;
    }
}